<template>
  <section class="personal-data-form">
    <h2>Dados Pessoais</h2>
    <form action="">
      <input
        type="text"
        v-model="name"
        placeholder="Nome">
      <input-error-message
        :hasError="!validName">
        Nome inválido
      </input-error-message>
      <input
        type="text"
        v-model="nusp"
        placeholder="Nº USP">
      <input-error-message
        :hasError="!validNUSP">
        Nº USP inválido
      </input-error-message>
    </form>
  </section>
</template>

<script>
import InputErrorMessage from '~/components/InputErrorMessage.vue'

export default {
  computed: {
    name: {
      get() {
        return this.$store.getters.signupInfo.name;
      },
      set (value) {
        this.$store.commit('setSignupName', value);
      }
    },
    nusp: {
      get() {
        return this.$store.getters.signupInfo.nusp;
      },
      set (value) {
        this.$store.commit('setSignupNusp', value);
      }
    },
    validName() {
      let isValid = this.name.length > 0 && this.name.length <= 50;
      this.$store.commit('setSignupError', {type: 'name', value: !isValid});
      return isValid;
    },
    validNUSP() {
      let isValid = this.nusp.match(/^\d{6,9}$/);
      this.$store.commit('setSignupError', {type: 'nusp', value: !isValid});
      return isValid;
    }
  },
  components: {
    InputErrorMessage
  }
}
</script>